/*
	IDropTarget Interface for Wharf

	Copyright (c) 2002 Joshua Seagoe
	Copyright (c) 2004 Sergey Gagarin a.k.a. Seg@
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __DROPTARGET_HEADER__
#define __DROPTARGET_HEADER__

#include "oleidl.h"

// #define USE_PIDL

class wharfType;

class WharfDropTarget : public IDropTarget
{
public:
	WharfDropTarget m_pDropTarget();
//		Required interface.
	HRESULT STDMETHODCALLTYPE QueryInterface( 
		REFIID riid,
		void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG STDMETHODCALLTYPE AddRef( void);

	ULONG STDMETHODCALLTYPE Release( void);

	HRESULT STDMETHODCALLTYPE DragEnter( 
		IDataObject *pDataObj,
		DWORD grfKeyState,
		POINTL pt,
		DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragOver( 
		DWORD grfKeyState,
		POINTL pt,
		DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragLeave( void);

	HRESULT STDMETHODCALLTYPE Drop( 
		IDataObject *pDataObj,
		DWORD grfKeyState,
		POINTL pt,
		DWORD *pdwEffect);

//		Locally used stuff.

	HRESULT Register(wharfType *parent);
	HRESULT static Revoke(HWND wnd)
	{
		return RevokeDragDrop(wnd);
	}

	static void RegisterFormats(void);

	wharfType *m_pWharf;

	static UINT cf_types[8];
	typedef void (WharfDropTarget::*DropFuncPtr)(void *);
	static DropFuncPtr cf_actions[8];
	int cf_index;

	void Drop_HDROP(void *);
	void Drop_INETURL(void *);
	void Drop_SHELLURL(void *);
	void Drop_TEXT(void *);
	void Drop_UNICODETEXT(void *);

#ifdef USE_PIDL
	void Drop_SHELLIDLIST(void *);
#endif
};

#endif
